
package xelfi.browser.document;

import xelfi.util.EnhProperties;

public class BrSettings
{
    public BrSettings()
    {
    }
    public BrSettings(BrSettings s)
    {
        // Global
        Columns       = s.Columns;
        Mode          = s.Mode;
        MultipleSelectioned   = s.MultipleSelectioned;
        Dialog        = s.Dialog;
        Choice        = s.Choice;
        Checkbox      = s.Checkbox;
        // Members
        MemVariable   = s.MemVariable;
        MemMethod     = s.MemMethod;
        MemShowModif  = s.MemShowModif;
        MemShowType   = s.MemShowType;
        MemShowInit   = s.MemShowInit;
        MemIndent     = s.MemIndent;
        MemSort       = s.MemSort;
        // Objects
        ObjClass      = s.ObjClass;
        ObjInterface  = s.ObjInterface;
        ObjPrjOnly    = s.ObjPrjOnly;
        ObjShowModif  = s.ObjShowModif;
        ObjSort       = s.ObjSort;

        PackProject   = s.PackProject;
        PackSystem    = s.PackSystem;
    }
    public BrSettings(EnhProperties prop,int num)
    {
        String s = "Browser" + ((num == -1) ? "" : ("" + num)) + ".";

        Columns = prop.getIntProperty(s +     "Columns"              ,Columns);
        Mode = prop.getIntProperty(s +     "Mode"                 ,Mode);
        MultipleSelectioned = prop.getBooleanProperty(s + "MultipleSelectioned"  ,MultipleSelectioned);
        Dialog = prop.getBooleanProperty(s + "Dialog"               ,Dialog);
        Choice = prop.getBooleanProperty(s + "Choice"               ,Choice);
        Checkbox = prop.getBooleanProperty(s + "Checkbox"             ,Checkbox);
        // Members
        MemVariable = prop.getBooleanProperty(s + "MemVariable"          ,MemVariable);
        MemMethod = prop.getBooleanProperty(s + "MemMethod"            ,MemMethod);
        MemShowModif = prop.getBooleanProperty(s + "MemShowModif"         ,MemShowModif);
        MemShowType = prop.getBooleanProperty(s + "MemShowType"          ,MemShowType);
        MemShowInit = prop.getBooleanProperty(s + "MemShowInit"          ,MemShowInit);
        MemIndent = prop.getIntProperty(s +     "MemIndent"            ,MemIndent);
        MemSort = prop.getIntProperty(s +     "MemSort"              ,MemSort);
        // Objects
        ObjClass = prop.getBooleanProperty(s + "ObjClass"             ,ObjClass);
        ObjInterface = prop.getBooleanProperty(s + "ObjInterface"         ,ObjInterface);
        ObjPrjOnly = prop.getBooleanProperty(s + "ObjPrjOnly"           ,ObjPrjOnly);
        ObjShowModif = prop.getBooleanProperty(s + "ObjShowModif"         ,ObjShowModif);
        ObjSort = prop.getIntProperty(s +     "ObjSort"              ,ObjSort);

        PackProject = prop.getBooleanProperty(s + "PackProject"          ,PackProject);
        PackSystem = prop.getBooleanProperty(s + "PackSystem"           ,PackSystem);
    }
    public void storeProperty(EnhProperties prop,int num)
    {
        String s = "Browser" + ((num == -1) ? "" : ("" + num)) + ".";

        prop.setIntProperty(s +     "Columns"              ,Columns);
        prop.setIntProperty(s +     "Mode"                 ,Mode);
        prop.setBooleanProperty(s + "MultipleSelectioned"  ,MultipleSelectioned);
        prop.setBooleanProperty(s + "Dialog"               ,Dialog);
        prop.setBooleanProperty(s + "Choice"               ,Choice);
        prop.setBooleanProperty(s + "Checkbox"             ,Checkbox);
        // Members
        prop.setBooleanProperty(s + "MemVariable"          ,MemVariable);
        prop.setBooleanProperty(s + "MemMethod"            ,MemMethod);
        prop.setBooleanProperty(s + "MemShowModif"         ,MemShowModif);
        prop.setBooleanProperty(s + "MemShowType"          ,MemShowType);
        prop.setBooleanProperty(s + "MemShowInit"          ,MemShowInit);
        prop.setIntProperty(s +     "MemIndent"            ,MemIndent);
        prop.setIntProperty(s +     "MemSort"              ,MemSort);
        // Objects
        prop.setBooleanProperty(s + "ObjClass"             ,ObjClass);
        prop.setBooleanProperty(s + "ObjInterface"         ,ObjInterface);
        prop.setBooleanProperty(s + "ObjPrjOnly"           ,ObjPrjOnly);
        prop.setBooleanProperty(s + "ObjShowModif"         ,ObjShowModif);
        prop.setIntProperty(s +     "ObjSort"              ,ObjSort);

        prop.setBooleanProperty(s + "PackProject"          ,PackProject);
        prop.setBooleanProperty(s + "PackSystem"           ,PackSystem);
    }
    // Global
    public int     Columns       = 2;
    public int     Mode          = 3;
    public boolean MultipleSelectioned   = false;
    public boolean Dialog        = false;
    public boolean Choice        = true;
    public boolean Checkbox      = true;

    // Members
    public boolean MemVariable   = true;
    public boolean MemMethod     = true;
    public boolean MemShowModif  = false;
    public boolean MemShowType   = true;
    public boolean MemShowInit   = true;
    public int     MemIndent     = 8;
    public int     MemSort       = 0;// 0 - no 1 - abc 2 - abc +
                                     // vse v jednom

    // Objects
    public boolean ObjClass      = true;
    public boolean ObjInterface  = true;
    public boolean ObjPrjOnly    = false;
    public boolean ObjShowModif  = true;
    public int     ObjSort       = 2;// 0 - no 1 - abecedni
                                     // 2 - extends 3 - implem.

    // Packages
    public boolean PackProject   = true;
    public boolean PackSystem    = true;

}
