/**
 * DebuggerOptions
 *
 * @author Roman Blazevic
 * @version 970208
 */

/**
 * This class stores the Debugger settings.
 */

package xelfi.debugger;

import xelfi.util.EnhProperties;

class DebuggerOptions
{
	boolean showArrayIndexesFlag;
	int depthOfRecursiveWatching;

	/**
	 * DebuggerOptions constructor.
	 */
	DebuggerOptions()
	{ }

	/**
	 * Sets the show array indexes flag.
	 */
	void setShowArrayIndexes(boolean showArrayIndexesFlag)
	{
		this.showArrayIndexesFlag = showArrayIndexesFlag;
	}

	/**
	 * Sets the depth of the recursive watching.
	 */
	void setDepthOfRecursiveWatching(int depthOfRecursiveWatching)
	{
		this.depthOfRecursiveWatching = depthOfRecursiveWatching;
	}
	 
	/**
	 * Gets the show array indexes flag.
	 */
	boolean showArrayIndexes()
	{
		return showArrayIndexesFlag;
	}

	/**
	 * Gets the detpth of the recursive watching.
	 */
	int getDepthOfRecursiveWatching()
	{
		return depthOfRecursiveWatching;
	}

	/**
	 * Gets the (debugger options) properties.
	 */
	void getProperties(EnhProperties properties)
	{
		showArrayIndexesFlag = properties.getBooleanProperty("ShowArrayIndexes", false);
		depthOfRecursiveWatching = properties.getIntProperty("DepthOfRecursiveWatching", 2);
	}

	/**
	 * Puts the (debugger options) properties.
	 */
	void putProperties(EnhProperties properties)
	{
		properties.setBooleanProperty("ShowArrayIndexes", showArrayIndexesFlag);
		properties.setIntProperty("DepthOfRecursiveWatching", depthOfRecursiveWatching);
	}
}
