/**
* Xelfi
*/

package xelfi.design.components.property;

import java.io.*;
import java.awt.Color;
import java.awt.Frame;
import xelfi.design.components.XelfiDesignComponent;
import xelfi.design.components.dialogs.StringArraySelectThread;
import xelfi.util.Debug;


/**
 *
 * @version 	1.50, 08 Feb 1997 (from version 1.30 persistence is added)
 * @author 	Ian Formanek, Petr Hamernik
 */

public class XStringArrayPropertyType {
	public static void invokeSpecialInput(Frame parent, XelfiDesignComponent aXdc, int aPropNum) {
		new StringArraySelectThread("ArrayStringSelectThread", parent, aXdc, aPropNum).start(); 
	}

	public static String viewString(Object property) { return "[Array of String]"; }

	public static String[] removeEmptyStrings(String ar[]) {
		int j=0;
		for (int i=0; i<ar.length; i++)
			if ("".equalsIgnoreCase(ar[i])) j++;
		String newAr[] = new String[ar.length-j];
		j=0;
		for (int i=0; i<ar.length; i++)
			if (!"".equalsIgnoreCase(ar[i]))
				newAr[j++] = ar[i];
		return newAr;
	}

	public static void saveToStream(Object property, DataOutput stream) throws 
		IOException {
		String list[] = (String[])property;
		stream.writeInt(list.length);
		for (int i=0; i<list.length; i++)
			stream.writeUTF(list[i]);
		Debug.debug(Debug.PROPIO_SAVE, "XStringArrayProperty saved - length:"+list.length);
	}

	public static String[] loadFromStream(DataInput stream) throws 
		IOException {
		int len = stream.readInt();
		Debug.debug(Debug.PROPIO_LOAD, "XStringArrayProperty load - length:"+len);
		String list[] = new String[len];
		for (int i=0; i<len; i++) {
			list[i] = stream.readUTF();
			Debug.debug(Debug.PROPIO_LOAD, "XStringArrayProperty load - ["+i+"]: "+list[i]);
		}		
		return list;
	}
}
