/**
* Xelfi
*/

package xelfi.design.components.xawt;

/**
  *
  * @version 	2.12, 03 Apr 1997
  * @author 	Petr Hamernik
  *
  */

import java.awt.*;
import java.io.*;
import java.util.StringTokenizer;
import xelfi.awt.ImageLabel;
import xelfi.util.XelfiPath;
import xelfi.design.components.*;
import xelfi.design.components.property.*;
import xelfi.design.forms.XelfiDesignForm;
import xelfi.design.util.*;

public class XImageLabel extends XAWTPanel {
	private ImageLabel imLab;

	private static int propertyCount = 8;
	private Object propDef[];
	private boolean propDefSet = false;
	private static int eventCount = 2;
	private String events[] = new String[eventCount];
	protected static Image icon = null;

	protected XFImageName iName;
	
	public XImageLabel() { 
		super(XAWTPanel.WITHOUT_DRAGBORDER);
		defaultImage();
		setImageLabel(iName);
		propDef = new Object[propertyCount];
		for (int i=0; i<propertyCount; i++)
			propDef[i] = null;
		if (icon == null)
			icon = loadIcon("image.gif");
		parentColor = false;
	}

	protected void regenForm(int what) {
		if (parentForm != null)
			parentForm.regenerateCode(this, what);
	}

	public String[] neededImports() {
		String[] ret = new String[1];
		ret[0] = "xelfi.awt.ImageLabel";
		return ret;
	}

	public Image getIcon() {
		return icon; 
	}

	public boolean handleEvent(Event evt) {
		evt.target = this;
		return super.handleEvent(evt);
	}

	protected boolean setImageLabel(XFImageName aIName) {
		boolean b = true;
		iName = aIName;
		if (iName.isURL())
			imLab = new ImageLabel(iName.getText1());
		if (iName.isPath()) {
			Image im = Toolkit.getDefaultToolkit().getImage(iName.getText1());
			if (im == null) {
				b = false;
				defaultImage();
				im = Toolkit.getDefaultToolkit().getImage(iName.getText1());
			}
			imLab = new ImageLabel(im);
		}
		if (iName.isPackage()) {
			//PENDING
		}
		removeAll();
		add("Center", imLab);
		imLab.hide();
		imLab.show();
		component = imLab;
		if (autoSize)
			setDesignSize(0,0);
		else {
			Dimension dd = getSize();
			setDesignSize(dd.width, dd.height);
		}
		repaintComponent();
		imLab.repaint();
		regenForm(XFDesignConstants.GEN_ALL);
		return b;
	}

	protected void defaultImage() {
		String sep = new String(System.getProperty("file.separator"));
		String s = XelfiPath.get() + sep + "images" + sep + "sample1.gif";
		iName = new XFImageName(XFImageName.IN_PATH, s);
	}

	
	private boolean propertyDefault(int i) throws XFPropertyIndexOutOfBoundsException {
		if (propDefSet)
			propertiesSetDefault();
		if (propDef[i] == null)
			return false;
		switch (i) {
			case 0: return (((Boolean) propDef[i]).booleanValue() == imLab.isEnabled());
			case 1: return (((Boolean) propDef[i]).booleanValue() == bVisible);
			case 2: return (((Boolean) propDef[i]).booleanValue() == autoSize);
			case 3: return false;
			case 4: return (((Boolean) propDef[i]).booleanValue() == imLab.getStretch());
			case 5: if (getParent() != null)
						return (getParent().getBackground().getRGB() 
							== imLab.getBackground().getRGB());
					else
						return false;
			case 6: return (imLab.getBorderWidth() == 0);
			case 7: return (((Boolean) propDef[i]).booleanValue() == parentColor);
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	private void propertiesSetDefault() {
		if (propDefSet)
			return;
		propDefSet = true;
		propDef[0] = new Boolean(imLab.isEnabled());
		propDef[1] = new Boolean(bVisible);
		propDef[2] = new Boolean(autoSize);
		propDef[3] = new XFImageName(iName);
		propDef[4] = new Boolean(imLab.getStretch());
		propDef[5] = new Boolean(false);
		propDef[6] = new Integer(0);
		propDef[7] = new Boolean(parentColor);
	}

	public int getPropertyCount() { return propertyCount; }
	
	public Object getProperty(int index) throws XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0: return (imLab.isEnabled()) ? Boolean.TRUE : Boolean.FALSE;
			case 1: return (bVisible) ? Boolean.TRUE : Boolean.FALSE;
			case 2: return (autoSize) ? Boolean.TRUE : Boolean.FALSE;
			case 3: return iName;
			case 4: return (imLab.getStretch()) ? Boolean.TRUE : Boolean.FALSE;
			case 5: return imLab.getBackground();
			case 6: return new Integer(imLab.getBorderWidth());
			case 7: return (parentColor) ? Boolean.TRUE : Boolean.FALSE;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}
			
	public String[] getPropertyNames() { 
		String list[] = new String[propertyCount];
		list[0] = "Enabled";
		list[1] = "Visible";
		list[2] = "Auto Size";
		list[3] = "Image";
		list[4] = "Stretch";
		list[5] = "Background Color";
		list[6] = "Border Width";
		list[7] = "Parent Color";
		return list;
	}
		
	public String getPropertyString(int index) throws 
		XFPropertyIndexOutOfBoundsException { 
		switch (index) {
			case 0:
			case 1:
			case 2: return XBooleanPropertyType.viewString(getProperty(index));
			case 3: return XImageNamePropertyType.viewString(getProperty(index));
			case 4: return XBooleanPropertyType.viewString(getProperty(index));
			case 5: return XColorPropertyType.viewString(getProperty(index));
			case 6: return XIntegerPropertyType.viewString(getProperty(index));
			case 7: return XBooleanPropertyType.viewString(getProperty(index));
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int getPropertyViewerType(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			case 0: 
			case 1: 
			case 2: return XFDesignConstants.PVT_CHECK;
			case 3: return XFDesignConstants.PVT_SPECIAL;
			case 4: return XFDesignConstants.PVT_CHECK;
			case 5: return XFDesignConstants.PVT_SPECIAL;
			case 6: return XFDesignConstants.PVT_INPUT_INT;
			case 7: return XFDesignConstants.PVT_CHECK;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public String[] getPropertyValueNames(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public Object[] getPropertyValueValues(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		switch (index) {
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public int setProperty(int index, Object value) throws 	
		XFPropertyIndexOutOfBoundsException,
		XFPropertyBadValueTypeException 
	{ 
		int ret = XFDesignConstants.RSP_OK;
		int regen = XFDesignConstants.GEN_SETPROPS;
		if (!propDefSet)
			propertiesSetDefault();
		switch (index) { 
			case 0:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					imLab.enable(((Boolean)value).booleanValue());
					break;
			case 1: if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					bVisible = ((Boolean)value).booleanValue();
					break;
			case 2:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setAutoSize(((Boolean)value).booleanValue());
					if (autoSize) {
						setDesignSize(0,0);
						ret = ret | XFDesignConstants.RSP_OTHER_PROP;
						imLab.repaint();
					}
					regen = regen | XFDesignConstants.GEN_RESHAPE;
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 3:if (!(value instanceof XFImageName)) throw new XFPropertyBadValueTypeException();
					setImageLabel((XFImageName)value);
				 	ret = ret | XFDesignConstants.RSP_OTHER_PROP | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 4:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					imLab.setStretch(((Boolean)value).booleanValue());
					if (autoSize)
						setDesignSize(0,0);
					repaintComponent();
					ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			case 5:if (!(value instanceof Color)) throw new XFPropertyBadValueTypeException();
					imLab.setBackground((Color)value);
				 	ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					hide();
					show();
					repaintComponent();
					break;
			case 6:if (!(value instanceof Integer)) throw new XFPropertyBadValueTypeException();
					imLab.setBorderWidth(((Integer)value).intValue());
				 	ret = ret | XFDesignConstants.RSP_OTHER_PROP | XFDesignConstants.RSP_REPAINT_COMP;
					if (autoSize)
						setDesignSize(0,0);
					repaintComponent();
					break;
			case 7:	if (!(value instanceof Boolean)) throw new XFPropertyBadValueTypeException();
					setParentColor(((Boolean)value).booleanValue());
					if (parentColor)
						ret = ret | XFDesignConstants.RSP_REPAINT_COMP;
					break;
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
		regenForm(regen);
		
		return ret;
	}
			
	public void specialPropertyInput(Frame parent, int index) throws 	
		XFPropertyIndexOutOfBoundsException, 
		XFPropertyNoSpecialInputException { 
		if ((index < 0) || (index >= propertyCount)) throw new XFPropertyIndexOutOfBoundsException();
		switch (index) { 
			case 3: XImageNamePropertyType.invokeSpecialInput(parent, this, index);
					break;
			case 5: XColorPropertyType.invokeSpecialInput(parent, this, index);
					break;
			default: throw new XFPropertyNoSpecialInputException();
		}
	}

	public int getEventCount() {
		return eventCount;
	}

	public String[] getEventNames() {
		String list[] = new String[eventCount];
		list[0] = "OnGotFocus";
		list[1] = "OnLostFocus";
		return list;
	}

	public String getEvent(int index) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount)) {
			if (events[index] == null)
				return null;
			else
				return new String(events[index]); 
		}
		else throw new XFPropertyIndexOutOfBoundsException();
	}		
		
	public void setEvent(int index, String value) throws 
		XFPropertyIndexOutOfBoundsException {
		if ((index>=0) && (index<eventCount))
			events[index] = value;
		else throw new XFPropertyIndexOutOfBoundsException();
	}		

	public String getClassName() {
		return "ImageLabel";
	}

	private String conv(String source) {
		String dest = "";
		StringTokenizer st = new StringTokenizer(source, "\\");
		dest += st.nextToken();
		while (st.hasMoreTokens()) { 
			dest += "\\\\" + st.nextToken();
		}
		return dest;
	}

	public String generateCode(int what) {
		String gen = "";
		switch (what) {
			case XFDesignConstants.GEN_VARIABLE: 
				gen = getClassName()+" "+ name + ";\n";
				break;
			case XFDesignConstants.GEN_INIT:
				if (iName.isURL()) {
					gen = name + " = new " + getClassName() + "(\"" +
						conv(iName.getText1()) + "\");\n";
				}
				if (iName.isPath()) {
					gen = name + " = new " + getClassName() + "(Toolkit.getDefaultToolkit().getImage(\"" +
						conv(iName.getText1()) + "\"));\n";
				}
				if (iName.isPackage()) {
					//PENDING
				}
				break;
			case XFDesignConstants.GEN_SETPROPS:
				if (!propDefSet)
					propertiesSetDefault();
				for (int i = 0; i < propertyCount; i++) {
					if (!propertyDefault(i)) {
						switch(i) {
							case 0: gen = gen + name + (imLab.isEnabled() ? ".enable();\n" : ".disable();\n");
									break;
							case 1: gen = gen + name + ((bVisible) ? ".show();\n" : ".hide();\n");
									break;
							case 4: gen = gen + name + ".setStretch(" +
										(imLab.getStretch() ? "true" : "false") + ");\n";
									break;
							case 5: if (!parentColor)
										gen = gen + name + ".setBackground(" +
											XFDesignUtils.genColor(imLab.getBackground()) + ");\n";
									break;
							case 6: gen = gen + name + ".setBorderWidth(" + imLab.getBorderWidth() + ");\n";
									break;
						}
					}
				}
				break;			
			case XFDesignConstants.GEN_RESHAPE:
				if (((XelfiVisualContainer) getParent()).getDesignLayout().allowsDragging()) {
					if (!autoSize) 
						if (getParent() instanceof XelfiDesignForm)
							gen = name + ".reshape(insets.left+"+position.x+", insets.top+"+position.y+","+size.width+","+size.height+");\n";
						else 
							gen = name + ".reshape("+position.x+","+position.y+","+size.width+","+size.height+");\n";
					else {
						gen = name + ".resize(" + name + ".preferredSize());\n";
						if (getParent() instanceof XelfiDesignForm)
							gen = gen + name + ".move(insets.left+"+position.x+", insets.top+"+position.y+");\n";
						else
							gen = gen + name + ".move("+position.x+","+position.y+");\n";
					}
				}
				break;
		}
		return gen;
	}

	public String generateEventCondition(int index) throws XFPropertyIndexOutOfBoundsException {
		String evt = XFDesignOptions.eventVarName;
		switch (index) { 
			case 0: return evt +".id == Event.GOT_FOCUS && "+evt+".target == "+getName();
			case 1: return evt +".id == Event.LOST_FOCUS && "+evt+".target == "+getName();
			default: throw new XFPropertyIndexOutOfBoundsException();
		}
	}

	public void loadFromStream(DataInput stream) throws IOException {

		super.loadFromStream(stream);

		if (!propDefSet)
			propertiesSetDefault();

		for (int i = 0; i < propertyCount; i++) {
			if (stream.readBoolean())
				propDef[i] = null;
			else switch (i) {
				case 0: imLab.enable(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 1: bVisible = XBooleanPropertyType.loadBFromStream(stream); break;
				case 2: setAutoSize(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 3: setImageLabel(XImageNamePropertyType.loadFromStream(stream)); break;
				case 4: imLab.setStretch(XBooleanPropertyType.loadBFromStream(stream)); break;
				case 5: imLab.setBackground(XColorPropertyType.loadFromStream(stream)); break;
				case 6: imLab.setBorderWidth(XIntegerPropertyType.loadFromStream(stream).intValue()); break;
				case 7: setParentColor(XBooleanPropertyType.loadBFromStream(stream)); break;
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if (stream.readBoolean())
				parentForm.assignEvent(this, i, stream.readUTF());
		}
	}		
	
	public void saveToStream(DataOutput stream) throws IOException {

		super.saveToStream(stream);

		for (int i = 0; i < propertyCount; i++) {
			boolean b = propertyDefault(i);
			stream.writeBoolean(b);
			if (!b) {
				switch (i) {
					case 0: XBooleanPropertyType.saveToStream(imLab.isEnabled(), stream); break;
					case 1: XBooleanPropertyType.saveToStream(bVisible, stream); break;
					case 2: XBooleanPropertyType.saveToStream(autoSize, stream); break;
					case 3: XImageNamePropertyType.saveToStream(iName, stream); break;
					case 4: XBooleanPropertyType.saveToStream(imLab.getStretch(), stream); break;
					case 5: XColorPropertyType.saveToStream(imLab.getBackground(), stream); break;
					case 6: XBooleanPropertyType.saveToStream(parentColor, stream); break;
					case 7: XIntegerPropertyType.saveToStream(new Integer(imLab.getBorderWidth()), stream); break;
				}
			}
		}

		for (int i = 0; i < eventCount; i++) {
			if ((events[i] != null) && (events[i].length() > 0)) {
				stream.writeBoolean(true);
				stream.writeUTF(events[i]);
			}
			else stream.writeBoolean(false);
		}
	}
	
}