/**
*
*/

package xelfi.design.forms;
import xelfi.editor.*;
import java.io.*;
/**
*
* @author Jaroslav Tulach
* @version 1.0
*/
public class FormHandler extends Object implements DocumentHandler {
  XelfiDesignForm form;
  
  /** Handler for specified form.
  * @param df design form
  */
  public FormHandler (XelfiDesignForm df) {
    form = df;
  }

  /** Calls StandardDocumentHandler.save () to save the source file.
  * @see xelfi.editor.StandardSaver#save
  * @param s the source
  * @param backup is true if the backup files should be created
  * @exception IOException if an error occures and saving is not possible
  */
  public void saveSource (Source s, boolean backup) throws IOException {
//    if (!s.equals(formSource)) {
//      Debug.debug(Debug.ERROR, "STRANGE: Given Source is not same as this form's Source!!");
//      return;
//    }
    StandardDocumentHandler.save(s, backup); // saves genearated source (*.java)
    String jname = s.getFile().getFile().getPath();
    String fname = jname.substring(0, jname.lastIndexOf(".java")) + ".form";
    XFFormLoader.saveForm(form, fname); // saves form (*.form)
  };

  /** Shows the editor. Now calls top level. Bleee....
  * @param s the source
  */
  public void showAll (Source s) {
    xelfi.top.TopLevel.showEditor (s, false);
    xelfi.top.TopLevel.showForm (s, true);
  }

}





