/**
* Xelfi programming environment
*/

package xelfi.editor;
import xelfi.util.BinaryTreeCompare;
/**
* Compares positionbox objects with each
* other and with positions.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class CompareBox extends Object implements BinaryTreeCompare {
  /** function to compare objects 
  * @param first first object to compare
  * @param second second object to compare 
  * @return one of previous constants
  */
  public byte compare (Object first, Object second) {
    PositionBox pb = (PositionBox) first;
    Position p =
      second instanceof Position ? ((Position) second) : (((PositionBox) second).pos);

    switch (pb.pos.compare (p)) {
    case Position.DIFFERENT:
    case Position.LESS:
      return LESS;
    case Position.EQUAL:
      return EQUAL;
    case Position.GREATER:
    default:
      return GREATER;
    }
  };
};








