/**  Top level desktop frame
* @author Filip Dvorak
* @version 2.0
*/

package xelfi.top;

import java.awt.*;
/*import java.io.File;
import java.util.*;

import xelfi.design.forms.XelfiDesignForm;
import xelfi.xedit.JavaEditorFrame;
import xelfi.editor.*;
import xelfi.top.visual.EditorMenuItem;
import xelfi.util.MessageBox;

import xelfi.compiler.*;  // shortcuts to next and prev. errors
*/

  /** Inherit this class to create a xelfi top level desktop frame window.
   */
public class TopFrame extends Frame
{
  private TopWindowBase base;
  
  /** Calls matching constructor of Frame. */
  public TopFrame()
  {
    super();
    base = new TopWindowBase(this);
  }

  /** Calls matching constructor of Frame. */
  public TopFrame(String title)
  {
    super(title);
    base = new TopWindowBase(this);
  }

  public boolean handleEvent(Event ev)
  {
    if(base.handleEvent(ev)) return true;
    else return super.handleEvent(ev);
  }

    /** Handles Window menu items updating, setting window positions, etc. */
  public void show()
  {
    base.beforeShow();
    super.show();
  }

    /** Handles Window menu items updating. */
  public void hide()
  {
    super.hide();
    base.afterHide();
  }

  /** Handles focus switchinhg. Strategy is: focused is currently focused window. LastFocused is
    window that has last released the focus. Menu items are disabled when new window gets the
    focus over lastFocused window. */
  public boolean gotFocus(Event ev, Object what)
  {
    boolean bas = base.gotFocus(ev, what);
    boolean par = super.gotFocus(ev, what);
    return bas || par;
  }

  /** Handles focus switchinhg. The system needs to know the window that has got the focus. */
  public boolean lostFocus(Event ev, Object what)
  {
    boolean bas = base.lostFocus(ev, what);
    boolean par = super.lostFocus(ev, what);
    return bas || par;
  }

    /** Key shortcuts */
  public boolean keyDown(Event  e, int  key)
  {
    if(base.keyDown(e, key)) return true;
    else return super.keyDown(e, key);
  }

    /** Should be called before closing the frame is no longer needed. */
  public void dispose()
  {
    base.done();
    super.dispose();
  }

    /** Adds item to the list of focused items for this frame. Focused items are items that will be 
      automatically enabled/disabled when the frame receives/looses a focus. 
      @param itemId new focused item. */
  public void addFocusedItem(int itemId)
  {
    base.addFocusedItem(itemId);
  }

    /** Removes item from the list of focused items for this frame. Focused items are items that will be 
      automatically enabled/disabled when the frame receives/looses a focus. 
      @param itemId focused item to remove */
  public void removeFocusedItem(int itemId)
  {
    base.removeFocusedItem(itemId);
  }

  TopWindowBase getBase()
  {
    return base;
  }
}




