/** Row layout manager properties
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.top.visual;

import java.awt.*;

  /** "...Growth" values specifies weight of growth when extra space is distributen beetwen components.
      topSpaceGrowth, compGrowth, bottomSpaceGrowth: Vertical extra space - how much space to take
              for space above component, for the component and for space below the component.
              Sum of these values over all components should be 1.0 .
      leftSpaceGrowth, RightSpaceGrowth: Horizontal extra space in a row - component grows
              (1.0 - leftSpaceGrowth - RightSpaceGrowth) percent;
  */
public class RowLayoutProperties extends LayoutPropertiesBase
{

  public RowLayoutProperties()
  {
    super();
  }

  public RowLayoutProperties(Insets i)
  {
    super(i);
  }

  public RowLayoutProperties(float componentGrowth)
  {
    super(componentGrowth);
  }

  public RowLayoutProperties(Insets i, float componentGrowth)
  {
    super(i, componentGrowth);
  }

  public RowLayoutProperties(float componentGrowth, float topGrowth, float bottGrowth)
  {
    super(componentGrowth);
    topSpaceGrowth = topGrowth;
    bottomSpaceGrowth = bottGrowth;
  }

  public RowLayoutProperties(Insets i, float componentGrowth, float topGrowth, float bottGrowth)
  {
    super(i, componentGrowth);
    topSpaceGrowth = topGrowth;
    bottomSpaceGrowth = bottGrowth;
  }
}
