/**
* Xelfi programming environment
*/

package xelfi.util;
import java.util.Enumeration;
import java.util.NoSuchElementException;
/**
*
* Implements enumeration on binary trees
*
* @version 1.0
* @author Jaroslav Tulach
*/

class BinaryTreeEnumeration extends Object implements Enumeration {
  BinaryTreeNodeImpl node;
  
  public BinaryTreeEnumeration (BinaryTreeNode n) {
    node = n == null ? 
      null : (BinaryTreeNodeImpl)BinaryTreeOperation.leftestNode (n);
  };
  
  public boolean hasMoreElements () {
    return node != null;
  };
  
  public Object nextElement () { //throws NoSuchElementException {
    if (node == null) throw new NoSuchElementException ();
    
    Object o = node.getObject ();
    
    try {
      node = (BinaryTreeNodeImpl)BinaryTreeOperation.nextNode (node);
    } catch (NodeAccessException e) {
      node = null;
    };
    return o;
  };
};


